using System;
using System.Collections.Generic;
using System.Text;

using IBatisNet.DataMapper.TypeHandlers;

namespace IBatisInAction.Common
{
    public class GuidVarcharTypeHandlerCallback : ITypeHandlerCallback
    {
        private const string GUID_NULL = "00000000-0000-0000-0000-000000000000";

        #region ITypeHandlerCallback Members

        public object ValueOf(string nullValue)
        {
            if (GUID_NULL.Equals(nullValue))
            {
                return Guid.Empty;
            }
            else
            {
                throw new Exception(
                 "Unexpected value " + nullValue +
                 " found where " + GUID_NULL + " was expected to represent a null value.");
            }
        }

        public object GetResult(IResultGetter getter)
        {
            try
            {
                Guid result = new Guid(getter.Value.ToString());
                return result;
            }
            catch
            {
                throw new Exception(
                "Unexpected value " + getter.Value.ToString() +
                " found where a valid GUID string value was expected.");
            }
        }

        public void SetParameter(IParameterSetter setter, object parameter)
        {
            setter.Value = parameter.ToString();
        }

        public object NullValue
        {
            get { return Guid.Empty; }
        }

        #endregion
    }
}
