using System;
using System.Collections.Generic;

namespace IBatisInAction.Domain
{
    #region Product

    /// <summary>
    /// Domain class of table [Products].
    /// </summary>
    [Serializable]
    public class Product
    {
        #region Private fields

        private int _productID;

        private string _productName = String.Empty;
        private int _supplierID;
        private string _quantityPerUnit = String.Empty;
        private decimal _unitPrice;
        private short _unitsInStock;
        private short _unitsOnOrder;
        private short _reorderLevel;
        private bool _discontinued;

        #endregion

        #region Constructors

        // Instantiate empty Product for inserting
        public Product() { }

        // Retrieve Product with Id for updating
        public Product(int productID)
        {
            this._productID = productID;
        }

        #endregion

        #region Public properties

        public int ProductID
        {
            get { return _productID; }
            set { _productID = value; }
        }


        public string ProductName
        {
            get { return _productName; }
            set { _productName = value; }
        }

        public int SupplierID
        {
            get { return _supplierID; }
            set { _supplierID = value; }
        }

        public string QuantityPerUnit
        {
            get { return _quantityPerUnit; }
            set { _quantityPerUnit = value; }
        }

        public decimal UnitPrice
        {
            get { return _unitPrice; }
            set { _unitPrice = value; }
        }

        public short UnitsInStock
        {
            get { return _unitsInStock; }
            set { _unitsInStock = value; }
        }

        public short UnitsOnOrder
        {
            get { return _unitsOnOrder; }
            set { _unitsOnOrder = value; }
        }

        public short ReorderLevel
        {
            get { return _reorderLevel; }
            set { _reorderLevel = value; }
        }

        public bool Discontinued
        {
            get { return _discontinued; }
            set { _discontinued = value; }
        }

        #endregion

        #region Extended Properties

        private Category _category = null;

        public Category Category
        {
            get { return _category; }
            set { _category = value; }
        }

        #endregion
    }

    #endregion
}
